﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyController : MonoBehaviour
{

	AudioSource ASource;

	public AudioClip plasmaCannonShoot;
	public AudioClip plasmaCannonHit;


	public Stats stats;
	GameManager gameManager;

	public int maxHealth = 100;
	[HideInInspector]public int health;

	public int maxEnergy = 100;
	[HideInInspector]public int energy;

	void Awake ()
	{
		ASource = GetComponent<AudioSource> ();
		gameManager = GameObject.Find ("WorldController").GetComponent<GameManager> ();
		stats = GameObject.Find ("WorldController").GetComponent<Stats> ();
	}

	void Start ()
	{
		health = maxHealth;
		energy = maxEnergy;
		StartCoroutine (HealShip ());
	}

	void OnTriggerEnter2D (Collider2D other)
	{
		if (other.tag == "Projectile") {
			TakeDamage (10 + (5 * stats.damageLevel));
		}
	}

	public void TakeDamage (int amount)
	{
		health -= amount;
		playSound ("PC_Hit");
		if (health < 0) {
			health = 0;
			gameManager.currency += 100;
			gameManager.totalEnemiesKilled++;
			Destroy (gameObject);
		}
	}

	public void Repair (int amount)
	{
		health += amount;
		if (health > maxHealth)
			health = maxHealth;
	}

	public void RemoveEnergy (int amount)
	{
		energy -= amount;
		if (energy < 0) {
			energy = 0;
		}
		if (energy > maxEnergy)
			energy = maxEnergy;
	}

	IEnumerator HealShip ()
	{
		while (true) {
			Repair (1);
			RemoveEnergy (-5);
			yield return new WaitForSeconds (0.5f);
		}
	}

	public void playSound (string sound)
	{
		switch (sound) {
		case "PC_Shoot":
			ASource.PlayOneShot (plasmaCannonShoot, 1);
			break;

		case "PC_Hit":
			ASource.PlayOneShot (plasmaCannonHit, 1);
			break;
		}
	}

}
