﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyMovement : MonoBehaviour
{

	public Transform player;

	Rigidbody2D rb2d;

	GameManager gameManager;

	void Awake ()
	{
		rb2d = GetComponent<Rigidbody2D> ();
		gameManager = GameObject.Find ("WorldController").GetComponent<GameManager> ();
	}

	void Update ()
	{
		processMovement (6f);
		processRotation (0.1f);
	}

	void processMovement (float speed)
	{
		Vector3 movement = transform.up * speed;
		rb2d.velocity = movement;
	}

	void processRotation (float strength)
	{
		Vector3 lookPos = player.position - transform.position;
		Vector3 nearbyEnemyAvoidance = Vector3.zero;
		if (Vector3.Distance (transform.position, player.transform.position) <= 4) {
			lookPos = -(player.position - transform.position);
		}// else {
		for (int i = 0; i < gameManager.allEnemies.Length; i++) {
			if (gameManager.allEnemies [i] != null && gameManager.allEnemies [i] != gameObject) {
				if (Vector3.Distance (transform.position, gameManager.allEnemies [i].transform.position) <= 2) {
					//lookPos = -(allEnemies [i].transform.position - transform.position);
					nearbyEnemyAvoidance += -(gameManager.allEnemies [i].transform.position - transform.position);
				}
			}
		}
		//}

		lookPos.Normalize ();
		float angle = Mathf.Atan2 (lookPos.y + nearbyEnemyAvoidance.y, lookPos.x + nearbyEnemyAvoidance.x) * Mathf.Rad2Deg;
		transform.rotation = Quaternion.Lerp (transform.rotation, Quaternion.Euler (0, 0, angle - 90), strength);
	}

}
