﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyShoot : MonoBehaviour
{

	public GameObject projectile;
	[HideInInspector]public bool waitForEnergy;
	int energyWaitAmount;

	void Start ()
	{
		energyWaitAmount = Random.Range (1, (int)(GetComponent<EnemyController> ().maxEnergy / 10) + 1) * 10;
	}

	float lastShootTime;

	void Update ()
	{

		if (GetComponent<EnemyController> ().energy < 10)
			waitForEnergy = true;

		if (waitForEnergy == true) {
			if (GetComponent<EnemyController> ().energy >= energyWaitAmount) {
				waitForEnergy = false;
			}
		}

		if (Time.time > lastShootTime + 0.2f) {
			if (GetComponent<EnemyController> ().energy > 10) {
				if (waitForEnergy == false) {
					RaycastHit2D[] hits = Physics2D.RaycastAll (transform.position, transform.up);
					bool canFire = false;
					for (int i = 0; i < hits.Length; i++) {
						if (hits [i].transform.tag == "Player") {
							canFire = true;
						}
					}
					if (canFire) {
						GetComponent<EnemyController> ().RemoveEnergy (10);
						shoot ();
						lastShootTime = Time.time;
					}
				}
			}
		}

	}

	void shoot ()
	{
		GetComponent<EnemyController> ().playSound ("PC_Shoot");

		GameObject newProj = (GameObject)Instantiate (projectile, transform.position, transform.rotation);
		newProj.GetComponent<Rigidbody2D> ().velocity = transform.up * 14;
		Destroy (newProj, 5);
	}

}
