﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class GameManager : MonoBehaviour
{

	public Text gameInfoText;

	public GameObject gameOverPanel;

	public int difficulity = 1;

	public Stats stats;


	[HideInInspector] public int currency;
	[HideInInspector] public int wave;
	[HideInInspector] public int totalEnemies;

	[HideInInspector] public int totalEnemiesKilled;

	[HideInInspector]public GameObject[] allEnemies;

	bool menuPanelOpen;

	void Start ()
	{
		wave = 0;
		totalEnemies = 0;
		currency = 0;

		StartCoroutine (getAllEnemies ());
	}

	void Update ()
	{
		totalEnemies = GameObject.FindGameObjectsWithTag ("Enemy").Length;

		processUI ();
		processInput ();
	}

	void processUI ()
	{
		string infoText = "";
		infoText += "Wave " + wave;
		infoText += "\nEnemies Remaining " + totalEnemies;
		infoText += "\n$" + currency;
		gameInfoText.text = infoText;
	}

	void processInput ()
	{
		if (Input.GetKeyDown (KeyCode.Alpha1)) {
			if (currency >= stats.getStatCost ("health")) {
				currency -= stats.getStatCost ("health");
				stats.upgradeStat ("health");
			}
		} else if (Input.GetKeyDown (KeyCode.Alpha2)) {
			if (currency >= stats.getStatCost ("energy")) {
				currency -= stats.getStatCost ("energy");
				stats.upgradeStat ("energy");
			}
		} else if (Input.GetKeyDown (KeyCode.Alpha3)) {
			if (currency >= stats.getStatCost ("damage")) {
				currency -= stats.getStatCost ("damage");
				stats.upgradeStat ("damage");
			}
		}
	}

	public IEnumerator displayGameOver ()
	{
		gameOverPanel.SetActive (true);
		gameOverPanel.transform.GetChild (0).GetComponent<Text> ().text =
			"Game Over" +
		"\nYou Reached Wave: " + wave +
		"\nAnd Killed " + totalEnemiesKilled + " Enemies";
		yield return new WaitForSeconds (10);
		GameObject.Find ("MenuManager").GetComponent<MenuManager> ().leaveGame ();
	}

	IEnumerator getAllEnemies ()
	{
		while (true) {
			allEnemies = GameObject.FindGameObjectsWithTag ("Enemy");
			yield return new WaitForSeconds (3);
		}
	}

}
