﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class PaintShip : MonoBehaviour
{

	public Texture2D shipTemplate;

	public Vector3 bodyColour;
	public Vector3 wingsColour;
	public Vector3 secondaryColour;

	public Image ship;

	public Slider bodyR;
	public Slider bodyG;
	public Slider bodyB;

	public Slider wingsR;
	public Slider wingsG;
	public Slider wingsB;

	public Slider secondaryR;
	public Slider secondaryG;
	public Slider secondaryB;

	void Start ()
	{
		updateShip ();
	}

	public Sprite currentSprite;

	public void updateShip ()
	{
		ship.sprite = paintShip (
			new Color32 ((byte)bodyR.value, (byte)bodyG.value, (byte)bodyB.value, 255),
			new Color32 ((byte)wingsR.value, (byte)wingsG.value, (byte)wingsB.value, 255),
			new Color32 ((byte)secondaryR.value, (byte)secondaryG.value, (byte)secondaryB.value, 255)
		);
	}

	Sprite paintShip (Color32 body, Color32 wings, Color32 secondary)
	{
		Texture2D newShip = new Texture2D (shipTemplate.width, shipTemplate.height);
		newShip.SetPixels (shipTemplate.GetPixels ());

		for (int x = 0; x < shipTemplate.width; x++) {
			for (int y = 0; y < shipTemplate.height; y++) {
				Color32 pix = (Color32)shipTemplate.GetPixel (x, y);

				if (pix.r == bodyColour.x && pix.g == bodyColour.y && pix.b == bodyColour.z) {//body
					newShip.SetPixel (x, y, body);
				} else if (pix.r == wingsColour.x && pix.g == wingsColour.y && pix.b == wingsColour.z) {//wings
					newShip.SetPixel (x, y, wings);
				} else if (pix.r == secondaryColour.x && pix.g == secondaryColour.y && pix.b == secondaryColour.z) {//secondary
					newShip.SetPixel (x, y, secondary);
				}

			}
		}
		newShip.Apply ();
		newShip.filterMode = FilterMode.Point;
		Sprite ship = Sprite.Create (newShip, new Rect (0, 0, newShip.width, newShip.height), new Vector2 (0.5f, 0.5f), 32);
		currentSprite = ship;
		return ship;
	}

}
