﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerMovement : MonoBehaviour
{

	Rigidbody2D rb2d;

	void Awake ()
	{
		rb2d = GetComponent<Rigidbody2D> ();
	}

	void Update ()
	{
		processMovement (6);
		processRotation (0.1f);
	}


	void processMovement (float speed)
	{
			Vector3 movement = transform.up * speed;
			rb2d.velocity = movement;
	}

	void processRotation (float strength)
	{
		Vector3 lookPos = Camera.main.ScreenToWorldPoint (Input.mousePosition) - transform.position;
		lookPos.Normalize ();
		float angle = Mathf.Atan2 (lookPos.y, lookPos.x) * Mathf.Rad2Deg;
		transform.rotation = Quaternion.Lerp (transform.rotation, Quaternion.Euler (0, 0, angle - 90), strength);
	}

}
